# coding: utf-8
"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python or TypeScript SDK.  To install the official [Python SDK](https://pypi.org/project/humanloop/), run the following command:  ```bash pip install humanloop ```  To install the official [TypeScript SDK](https://www.npmjs.com/package/humanloop), run the following command:  ```bash npm i humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://docs.humanloop.com/).

    The version of the OpenAPI document: 4.0.0
    Generated by: https://konfigthis.com
"""

import typing
import inspect
from datetime import date, datetime
from humanloop.client_custom import ClientCustom
from humanloop.configuration import Configuration
from humanloop.api_client import ApiClient
from humanloop.type_util import copy_signature
from humanloop.apis.tags.chats_api import ChatsApi
from humanloop.apis.tags.completions_api import CompletionsApi
from humanloop.apis.tags.experiments_api import ExperimentsApi
from humanloop.apis.tags.feedback_api import FeedbackApi
from humanloop.apis.tags.logs_api import LogsApi
from humanloop.apis.tags.model_configurations_api import ModelConfigurationsApi
from humanloop.apis.tags.projects_api import ProjectsApi
from humanloop.apis.tags.sessions_api import SessionsApi
from humanloop.apis.tags.traces_api import TracesApi

from humanloop.type.provider_api_keys import ProviderApiKeys
from humanloop.type.chat_message import ChatMessage
from humanloop.type.chat_request import ChatRequest
from humanloop.type.chat_response import ChatResponse
from humanloop.type.http_validation_error import HTTPValidationError
from humanloop.type.model_config_chat_request import ModelConfigChatRequest
from humanloop.type.provider_api_keys import ProviderApiKeys
from humanloop.type.chat_message import ChatMessage
from humanloop.type.chat_deployed_request import ChatDeployedRequest
from humanloop.type.chat_response import ChatResponse
from humanloop.type.http_validation_error import HTTPValidationError
from humanloop.type.provider_api_keys import ProviderApiKeys
from humanloop.type.chat_message import ChatMessage
from humanloop.type.chat_experiment_request import ChatExperimentRequest
from humanloop.type.chat_response import ChatResponse
from humanloop.type.http_validation_error import HTTPValidationError
from humanloop.type.chat_model_config_request import ChatModelConfigRequest
from humanloop.type.provider_api_keys import ProviderApiKeys
from humanloop.type.chat_message import ChatMessage
from humanloop.type.chat_response import ChatResponse
from humanloop.type.http_validation_error import HTTPValidationError
from humanloop.type.provider_api_keys import ProviderApiKeys
from humanloop.type.model_config_completion_request import ModelConfigCompletionRequest
from humanloop.type.completion_request import CompletionRequest
from humanloop.type.completion_response import CompletionResponse
from humanloop.type.http_validation_error import HTTPValidationError
from humanloop.type.completion_deployed_request import CompletionDeployedRequest
from humanloop.type.provider_api_keys import ProviderApiKeys
from humanloop.type.completion_response import CompletionResponse
from humanloop.type.http_validation_error import HTTPValidationError
from humanloop.type.provider_api_keys import ProviderApiKeys
from humanloop.type.completion_experiment_request import CompletionExperimentRequest
from humanloop.type.completion_response import CompletionResponse
from humanloop.type.http_validation_error import HTTPValidationError
from humanloop.type.provider_api_keys import ProviderApiKeys
from humanloop.type.completion_model_config_request import CompletionModelConfigRequest
from humanloop.type.completion_response import CompletionResponse
from humanloop.type.http_validation_error import HTTPValidationError
from humanloop.type.feedback_submit_request import FeedbackSubmitRequest
from humanloop.type.feedback_type import FeedbackType
from humanloop.type.feedback_submit_response import FeedbackSubmitResponse
from humanloop.type.http_validation_error import HTTPValidationError
from humanloop.type.feedback import Feedback
from humanloop.type.chat_message import ChatMessage
from humanloop.type.agent_config_request import AgentConfigRequest
from humanloop.type.generic_config_request import GenericConfigRequest
from humanloop.type.tool_config_request import ToolConfigRequest
from humanloop.type.logs_log_response import LogsLogResponse
from humanloop.type.trace_model_config_request import TraceModelConfigRequest
from humanloop.type.log_datapoint_request import LogDatapointRequest
from humanloop.type.http_validation_error import HTTPValidationError


class Humanloop(ClientCustom):

    def __init__(self, configuration: typing.Union[Configuration, None] = None, **kwargs):
        super().__init__(configuration, **kwargs)
        if (len(kwargs) > 0):
            configuration = Configuration(**kwargs)
        if (configuration is None):
            raise Exception("configuration is required")
        api_client = ApiClient(configuration)
        self.chats_api: ChatsApi = ChatsApi(api_client)
        self.completions_api: CompletionsApi = CompletionsApi(api_client)
        self.experiments: ExperimentsApi = ExperimentsApi(api_client)
        self.feedback_api: FeedbackApi = FeedbackApi(api_client)
        self.logs_api: LogsApi = LogsApi(api_client)
        self.model_configurations: ModelConfigurationsApi = ModelConfigurationsApi(api_client)
        self.projects: ProjectsApi = ProjectsApi(api_client)
        self.sessions: SessionsApi = SessionsApi(api_client)
        self.traces: TracesApi = TracesApi(api_client)

    @copy_signature(ChatsApi.aresponse)
    async def achat(
        self,
        project: str,
        messages: typing.List[ChatMessage],
        model_config: ModelConfigChatRequest,
        inputs: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
        source: typing.Optional[str] = None,
        provider_api_keys: typing.Optional[ProviderApiKeys] = None,
        num_samples: typing.Optional[int] = None,
        stream: typing.Optional[bool] = None,
        user: typing.Optional[str] = None,
        metadata: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
    ):
        return await self.chats_api.aresponse(
            project=project,
            messages=messages,
            model_config=model_config,
            inputs=inputs,
            source=source,
            provider_api_keys=provider_api_keys,
            num_samples=num_samples,
            stream=stream,
            user=user,
            metadata=metadata,
        )

    @copy_signature(ChatsApi.response)
    def chat(
        self,
        project: str,
        messages: typing.List[ChatMessage],
        model_config: ModelConfigChatRequest,
        inputs: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
        source: typing.Optional[str] = None,
        provider_api_keys: typing.Optional[ProviderApiKeys] = None,
        num_samples: typing.Optional[int] = None,
        stream: typing.Optional[bool] = None,
        user: typing.Optional[str] = None,
        metadata: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
    ):
        return self.chats_api.response(
            project=project,
            messages=messages,
            model_config=model_config,
            inputs=inputs,
            source=source,
            provider_api_keys=provider_api_keys,
            num_samples=num_samples,
            stream=stream,
            user=user,
            metadata=metadata,
        )

    @copy_signature(ChatsApi.aresponse_deployed)
    async def achat_deployed(
        self,
        project: str,
        messages: typing.List[ChatMessage],
        inputs: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
        source: typing.Optional[str] = None,
        provider_api_keys: typing.Optional[ProviderApiKeys] = None,
        num_samples: typing.Optional[int] = None,
        stream: typing.Optional[bool] = None,
        user: typing.Optional[str] = None,
        metadata: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
    ):
        return await self.chats_api.aresponse_deployed(
            project=project,
            messages=messages,
            inputs=inputs,
            source=source,
            provider_api_keys=provider_api_keys,
            num_samples=num_samples,
            stream=stream,
            user=user,
            metadata=metadata,
        )

    @copy_signature(ChatsApi.response_deployed)
    def chat_deployed(
        self,
        project: str,
        messages: typing.List[ChatMessage],
        inputs: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
        source: typing.Optional[str] = None,
        provider_api_keys: typing.Optional[ProviderApiKeys] = None,
        num_samples: typing.Optional[int] = None,
        stream: typing.Optional[bool] = None,
        user: typing.Optional[str] = None,
        metadata: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
    ):
        return self.chats_api.response_deployed(
            project=project,
            messages=messages,
            inputs=inputs,
            source=source,
            provider_api_keys=provider_api_keys,
            num_samples=num_samples,
            stream=stream,
            user=user,
            metadata=metadata,
        )

    @copy_signature(ChatsApi.aresponse_experiment)
    async def achat_experiment(
        self,
        project: str,
        messages: typing.List[ChatMessage],
        experiment_id: str,
        inputs: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
        source: typing.Optional[str] = None,
        provider_api_keys: typing.Optional[ProviderApiKeys] = None,
        num_samples: typing.Optional[int] = None,
        stream: typing.Optional[bool] = None,
        user: typing.Optional[str] = None,
        metadata: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
    ):
        return await self.chats_api.aresponse_experiment(
            project=project,
            messages=messages,
            experiment_id=experiment_id,
            inputs=inputs,
            source=source,
            provider_api_keys=provider_api_keys,
            num_samples=num_samples,
            stream=stream,
            user=user,
            metadata=metadata,
        )

    @copy_signature(ChatsApi.response_experiment)
    def chat_experiment(
        self,
        project: str,
        messages: typing.List[ChatMessage],
        experiment_id: str,
        inputs: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
        source: typing.Optional[str] = None,
        provider_api_keys: typing.Optional[ProviderApiKeys] = None,
        num_samples: typing.Optional[int] = None,
        stream: typing.Optional[bool] = None,
        user: typing.Optional[str] = None,
        metadata: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
    ):
        return self.chats_api.response_experiment(
            project=project,
            messages=messages,
            experiment_id=experiment_id,
            inputs=inputs,
            source=source,
            provider_api_keys=provider_api_keys,
            num_samples=num_samples,
            stream=stream,
            user=user,
            metadata=metadata,
        )

    @copy_signature(ChatsApi.aresponse_model_configuration)
    async def achat_model_configuration(
        self,
        project: str,
        messages: typing.List[ChatMessage],
        model_config_id: str,
        inputs: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
        source: typing.Optional[str] = None,
        provider_api_keys: typing.Optional[ProviderApiKeys] = None,
        num_samples: typing.Optional[int] = None,
        stream: typing.Optional[bool] = None,
        user: typing.Optional[str] = None,
        metadata: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
    ):
        return await self.chats_api.aresponse_model_configuration(
            project=project,
            messages=messages,
            model_config_id=model_config_id,
            inputs=inputs,
            source=source,
            provider_api_keys=provider_api_keys,
            num_samples=num_samples,
            stream=stream,
            user=user,
            metadata=metadata,
        )

    @copy_signature(ChatsApi.response_model_configuration)
    def chat_model_configuration(
        self,
        project: str,
        messages: typing.List[ChatMessage],
        model_config_id: str,
        inputs: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
        source: typing.Optional[str] = None,
        provider_api_keys: typing.Optional[ProviderApiKeys] = None,
        num_samples: typing.Optional[int] = None,
        stream: typing.Optional[bool] = None,
        user: typing.Optional[str] = None,
        metadata: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
    ):
        return self.chats_api.response_model_configuration(
            project=project,
            messages=messages,
            model_config_id=model_config_id,
            inputs=inputs,
            source=source,
            provider_api_keys=provider_api_keys,
            num_samples=num_samples,
            stream=stream,
            user=user,
            metadata=metadata,
        )

    @copy_signature(CompletionsApi.acreate)
    async def acomplete(
        self,
        project: str,
        inputs: typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]],
        model_config: ModelConfigCompletionRequest,
        source: typing.Optional[str] = None,
        provider_api_keys: typing.Optional[ProviderApiKeys] = None,
        num_samples: typing.Optional[int] = None,
        logprobs: typing.Optional[int] = None,
        stream: typing.Optional[bool] = None,
        suffix: typing.Optional[str] = None,
        user: typing.Optional[str] = None,
        metadata: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
    ):
        return await self.completions_api.acreate(
            project=project,
            inputs=inputs,
            model_config=model_config,
            source=source,
            provider_api_keys=provider_api_keys,
            num_samples=num_samples,
            logprobs=logprobs,
            stream=stream,
            suffix=suffix,
            user=user,
            metadata=metadata,
        )

    @copy_signature(CompletionsApi.create)
    def complete(
        self,
        project: str,
        inputs: typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]],
        model_config: ModelConfigCompletionRequest,
        source: typing.Optional[str] = None,
        provider_api_keys: typing.Optional[ProviderApiKeys] = None,
        num_samples: typing.Optional[int] = None,
        logprobs: typing.Optional[int] = None,
        stream: typing.Optional[bool] = None,
        suffix: typing.Optional[str] = None,
        user: typing.Optional[str] = None,
        metadata: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
    ):
        return self.completions_api.create(
            project=project,
            inputs=inputs,
            model_config=model_config,
            source=source,
            provider_api_keys=provider_api_keys,
            num_samples=num_samples,
            logprobs=logprobs,
            stream=stream,
            suffix=suffix,
            user=user,
            metadata=metadata,
        )

    @copy_signature(CompletionsApi.acreate_deployed)
    async def acomplete_deployed(
        self,
        project: str,
        inputs: typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]],
        source: typing.Optional[str] = None,
        provider_api_keys: typing.Optional[ProviderApiKeys] = None,
        num_samples: typing.Optional[int] = None,
        logprobs: typing.Optional[int] = None,
        stream: typing.Optional[bool] = None,
        suffix: typing.Optional[str] = None,
        user: typing.Optional[str] = None,
        metadata: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
    ):
        return await self.completions_api.acreate_deployed(
            project=project,
            inputs=inputs,
            source=source,
            provider_api_keys=provider_api_keys,
            num_samples=num_samples,
            logprobs=logprobs,
            stream=stream,
            suffix=suffix,
            user=user,
            metadata=metadata,
        )

    @copy_signature(CompletionsApi.create_deployed)
    def complete_deployed(
        self,
        project: str,
        inputs: typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]],
        source: typing.Optional[str] = None,
        provider_api_keys: typing.Optional[ProviderApiKeys] = None,
        num_samples: typing.Optional[int] = None,
        logprobs: typing.Optional[int] = None,
        stream: typing.Optional[bool] = None,
        suffix: typing.Optional[str] = None,
        user: typing.Optional[str] = None,
        metadata: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
    ):
        return self.completions_api.create_deployed(
            project=project,
            inputs=inputs,
            source=source,
            provider_api_keys=provider_api_keys,
            num_samples=num_samples,
            logprobs=logprobs,
            stream=stream,
            suffix=suffix,
            user=user,
            metadata=metadata,
        )

    @copy_signature(CompletionsApi.acreate_experiment)
    async def acomplete_experiment(
        self,
        project: str,
        inputs: typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]],
        experiment_id: str,
        source: typing.Optional[str] = None,
        provider_api_keys: typing.Optional[ProviderApiKeys] = None,
        num_samples: typing.Optional[int] = None,
        logprobs: typing.Optional[int] = None,
        stream: typing.Optional[bool] = None,
        suffix: typing.Optional[str] = None,
        user: typing.Optional[str] = None,
        metadata: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
    ):
        return await self.completions_api.acreate_experiment(
            project=project,
            inputs=inputs,
            experiment_id=experiment_id,
            source=source,
            provider_api_keys=provider_api_keys,
            num_samples=num_samples,
            logprobs=logprobs,
            stream=stream,
            suffix=suffix,
            user=user,
            metadata=metadata,
        )

    @copy_signature(CompletionsApi.create_experiment)
    def complete_experiment(
        self,
        project: str,
        inputs: typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]],
        experiment_id: str,
        source: typing.Optional[str] = None,
        provider_api_keys: typing.Optional[ProviderApiKeys] = None,
        num_samples: typing.Optional[int] = None,
        logprobs: typing.Optional[int] = None,
        stream: typing.Optional[bool] = None,
        suffix: typing.Optional[str] = None,
        user: typing.Optional[str] = None,
        metadata: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
    ):
        return self.completions_api.create_experiment(
            project=project,
            inputs=inputs,
            experiment_id=experiment_id,
            source=source,
            provider_api_keys=provider_api_keys,
            num_samples=num_samples,
            logprobs=logprobs,
            stream=stream,
            suffix=suffix,
            user=user,
            metadata=metadata,
        )

    @copy_signature(CompletionsApi.acreate_model_configuration)
    async def acomplete_model_configuration(
        self,
        project: str,
        inputs: typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]],
        model_config_id: str,
        source: typing.Optional[str] = None,
        provider_api_keys: typing.Optional[ProviderApiKeys] = None,
        num_samples: typing.Optional[int] = None,
        logprobs: typing.Optional[int] = None,
        stream: typing.Optional[bool] = None,
        suffix: typing.Optional[str] = None,
        user: typing.Optional[str] = None,
        metadata: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
    ):
        return await self.completions_api.acreate_model_configuration(
            project=project,
            inputs=inputs,
            model_config_id=model_config_id,
            source=source,
            provider_api_keys=provider_api_keys,
            num_samples=num_samples,
            logprobs=logprobs,
            stream=stream,
            suffix=suffix,
            user=user,
            metadata=metadata,
        )

    @copy_signature(CompletionsApi.create_model_configuration)
    def complete_model_configuration(
        self,
        project: str,
        inputs: typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]],
        model_config_id: str,
        source: typing.Optional[str] = None,
        provider_api_keys: typing.Optional[ProviderApiKeys] = None,
        num_samples: typing.Optional[int] = None,
        logprobs: typing.Optional[int] = None,
        stream: typing.Optional[bool] = None,
        suffix: typing.Optional[str] = None,
        user: typing.Optional[str] = None,
        metadata: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
    ):
        return self.completions_api.create_model_configuration(
            project=project,
            inputs=inputs,
            model_config_id=model_config_id,
            source=source,
            provider_api_keys=provider_api_keys,
            num_samples=num_samples,
            logprobs=logprobs,
            stream=stream,
            suffix=suffix,
            user=user,
            metadata=metadata,
        )

    @copy_signature(FeedbackApi.asubmit)
    async def afeedback(
        self,
        body: typing.Optional[FeedbackSubmitRequest] = None,
        type: typing.Optional[typing.Union[FeedbackType, str]] = None,
        value: typing.Optional[str] = None,
        data_id: typing.Optional[str] = None,
        user: typing.Optional[str] = None,
        created_at: typing.Optional[datetime] = None,
        unset: typing.Optional[bool] = None,
    ):
        return await self.feedback_api.asubmit(
            body=body,
            type=type,
            value=value,
            data_id=data_id,
            user=user,
            created_at=created_at,
            unset=unset,
        )

    @copy_signature(FeedbackApi.submit)
    def feedback(
        self,
        body: typing.Optional[FeedbackSubmitRequest] = None,
        type: typing.Optional[typing.Union[FeedbackType, str]] = None,
        value: typing.Optional[str] = None,
        data_id: typing.Optional[str] = None,
        user: typing.Optional[str] = None,
        created_at: typing.Optional[datetime] = None,
        unset: typing.Optional[bool] = None,
    ):
        return self.feedback_api.submit(
            body=body,
            type=type,
            value=value,
            data_id=data_id,
            user=user,
            created_at=created_at,
            unset=unset,
        )

    @copy_signature(LogsApi.alog)
    async def alog(
        self,
        body: typing.Optional[LogDatapointRequest] = None,
        project: typing.Optional[str] = None,
        reference_id: typing.Optional[str] = None,
        session_id: typing.Optional[str] = None,
        session_reference_id: typing.Optional[str] = None,
        parent_id: typing.Optional[str] = None,
        parent_reference_id: typing.Optional[str] = None,
        trial_id: typing.Optional[str] = None,
        inputs: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
        messages: typing.Optional[typing.List[ChatMessage]] = None,
        output: typing.Optional[str] = None,
        source: typing.Optional[str] = None,
        config: typing.Optional[typing.Union[TraceModelConfigRequest, ToolConfigRequest, GenericConfigRequest, AgentConfigRequest]] = None,
        metadata: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
        feedback: typing.Optional[typing.Union[Feedback, typing.List[Feedback]]] = None,
        created_at: typing.Optional[datetime] = None,
        error: typing.Optional[str] = None,
        duration: typing.Optional[typing.Union[int, float]] = None,
    ):
        return await self.logs_api.alog(
            body=body,
            project=project,
            reference_id=reference_id,
            session_id=session_id,
            session_reference_id=session_reference_id,
            parent_id=parent_id,
            parent_reference_id=parent_reference_id,
            trial_id=trial_id,
            inputs=inputs,
            messages=messages,
            output=output,
            source=source,
            config=config,
            metadata=metadata,
            feedback=feedback,
            created_at=created_at,
            error=error,
            duration=duration,
        )

    @copy_signature(LogsApi.log)
    def log(
        self,
        body: typing.Optional[LogDatapointRequest] = None,
        project: typing.Optional[str] = None,
        reference_id: typing.Optional[str] = None,
        session_id: typing.Optional[str] = None,
        session_reference_id: typing.Optional[str] = None,
        parent_id: typing.Optional[str] = None,
        parent_reference_id: typing.Optional[str] = None,
        trial_id: typing.Optional[str] = None,
        inputs: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
        messages: typing.Optional[typing.List[ChatMessage]] = None,
        output: typing.Optional[str] = None,
        source: typing.Optional[str] = None,
        config: typing.Optional[typing.Union[TraceModelConfigRequest, ToolConfigRequest, GenericConfigRequest, AgentConfigRequest]] = None,
        metadata: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = None,
        feedback: typing.Optional[typing.Union[Feedback, typing.List[Feedback]]] = None,
        created_at: typing.Optional[datetime] = None,
        error: typing.Optional[str] = None,
        duration: typing.Optional[typing.Union[int, float]] = None,
    ):
        return self.logs_api.log(
            body=body,
            project=project,
            reference_id=reference_id,
            session_id=session_id,
            session_reference_id=session_reference_id,
            parent_id=parent_id,
            parent_reference_id=parent_reference_id,
            trial_id=trial_id,
            inputs=inputs,
            messages=messages,
            output=output,
            source=source,
            config=config,
            metadata=metadata,
            feedback=feedback,
            created_at=created_at,
            error=error,
            duration=duration,
        )
